CapacityScaling< GR, V, C, TR >::SetHeap< T > Struct Template Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members
CapacityScaling< GR, V, C, TR >::SetHeap< T > Struct Template Reference

## Detailed Description

### template<typename GR, typename V, typename C, typename TR>
template<typename T>
struct lemon::CapacityScaling< GR, V, C, TR >::SetHeap< T >

Named parameter for setting `Heap` type, which is used for internal Dijkstra computations. It must conform to the Heap concept, its priority type must be `Cost` and its cross reference type must be RangeMap<int>.

`#include <lemon/capacity_scaling.h>`

Inheritance diagram for CapacityScaling< GR, V, C, TR >::SetHeap< T >:
[legend]

## Additional Inherited Members
Public Types inherited from CapacityScaling< GR, V, C, SetHeapTraits< T > >
enum | ProblemType
| Problem type constants for the `run()` function. More...
typedef SetHeapTraits< T >::Digraph | Digraph
| The type of the digraph.
typedef SetHeapTraits< T >::Value | Value
| The type of the flow amounts, capacity bounds and supply values.
typedef SetHeapTraits< T >::Cost | Cost
| The type of the arc costs.
typedef SetHeapTraits< T >::Heap | Heap
| The type of the heap used for internal Dijkstra computations.
typedef SetHeapTraits< T > | Traits
| The traits class of the algorithm.
Public Member Functions inherited from CapacityScaling< GR, V, C, SetHeapTraits< T > >
| CapacityScaling (const GR &graph)
| Constructor. More...
CapacityScaling & | lowerMap (const LowerMap &map)
| Set the lower bounds on the arcs. More...
CapacityScaling & | upperMap (const UpperMap &map)
| Set the upper bounds (capacities) on the arcs. More...
CapacityScaling & | costMap (const CostMap &map)
| Set the costs of the arcs. More...
CapacityScaling & | supplyMap (const SupplyMap &map)
| Set the supply values of the nodes. More...
CapacityScaling & | stSupply (const Node &s, const Node &t, Value k)
| Set single source and target nodes and a supply value. More...
ProblemType | run (int factor=4)
| Run the algorithm. More...
CapacityScaling & | resetParams ()
| Reset all the parameters that have been given before. More...
CapacityScaling & | reset ()
| Reset the internal data structures and all the parameters that have been given before. More...
Number | totalCost () const
| Return the total cost of the found flow. More...
Value | flow (const Arc &a) const
| Return the flow on the given arc. More...
void | flowMap (FlowMap &map) const
| Copy the flow values (the primal solution) into the given map. More...
Cost | potential (const Node &n) const
| Return the potential (dual value) of the given node. More...
void | potentialMap (PotentialMap &map) const
| Copy the potential values (the dual solution) into the given map. More...
Public Attributes inherited from CapacityScaling< GR, V, C, SetHeapTraits< T > >
const Value | INF
| Constant for infinite upper bounds (capacities). More...